new 200,50000;

format /rd 8,4;
outwidth 250;
output file = cnew10.out reset;


library  maxlik;
#include maxlik.ext;
maxset;

nobs = 2786;


/*  Load in SSP data: cols 1-69=ia  */
load temp[] = c54r.dat;
ssp = reshape(temp,nobs,80);
clear temp;

mns=meanc(ssp);

vnames = { "ym1", "y0",
           "y1", "y2", "y3", "y4", "y5", "y6", "y7", "y8", "y9", "y10",
           "y11", "y12", "y13", "y14", "y15", "y16", "y17", "y18", "y19", "y20",
           "y21", "y22", "y23", "y24", "y25", "y26", "y27", "y28", "y29", "y30",
           "y31", "y32", "y33", "y34", "y35", "y36", "y37", "y38", "y39", "y40",
           "y41", "y42", "y43", "y44", "y45", "y46", "y47", "y48", "y49", "y50",
           "y51", "y52", "y53", "y54", "y55", "y56", "y57", "y58", "y59", "y60",
           "y61", "y62", "y63", "y64", "y65", "y66", "y67", "y68", "y69",
           "expt", "ten", "all69", "hsgrad", "basework", "exper", "noexp",
           "agelt25", "premos" }; 
print "means of input data set";
print mns;

r1=4;
print "mass point mixing pts=" r1;


	/*  Define variable names in LFP dataset for logit models  */

nobs=rows(ssp);
print "check of reshape: nobs=";
print nobs;
print "---------";

saved(ssp,"ssp1",vnames);


__maxvec = 600000;


 /* estimation */

_max_CovPar = 2; /*  1=Inv. Hessian; 2=XProduct of Scores; 3=QML */
_mlgrdh = 1e-3;
_mlstep = 5;  /*  Max gradient step */
_max_GradTol = 5e-4; /*  Grad tolerance: default = 1e-5  */
_max_Algorithm=5;

print "covariance matrix choice=" _max_CovPar;
print "1=inv H 2=outer prod 3=qml" ;
print "algorithm=" _max_Algorithm;
print "2=bfgs 3=dfp 5=bhhh";
print "___" ;
print "controls - quartic trend - interactions";


clear b0;
b0 = {-1.34, -1.02 , 3.00  , -5.34 , 3.5 ,
       4.74 , 2.0, -.9 , -.7, -.3, .8, -3,
 2, 6, 0 ,0,0} ;

print "starting values" b0;


p1=1/(1+exp(b0[15])+exp(b0[16])+exp(b0[17]));
p2=exp(b0[15])/(1+exp(b0[15])+exp(b0[16])+exp(b0[17]));
p3=exp(b0[16])/(1+exp(b0[15])+exp(b0[16])+exp(b0[17]));
p4=1-p1-p2-p3;
print "prob of mass pt 1= " p1;
print "prob of mass pt 2= " p2;
print "prob of mass pt 3= " p3;
print "prob of mass pt 3= " p4;

{bex,lex,gex,covex,retex} =
   maxprt( maxlik("ssp1",vnames,&likexog,b0) );
lex = nobs*lex;

print "Maximized log-likelihood= " lex;

p1=1/(1+exp(bex[15])+exp(bex[16])+exp(bex[17]));
p2=exp(bex[15])/(1+exp(bex[15])+exp(bex[16])+exp(bex[17]));
p3=exp(bex[16])/(1+exp(bex[15])+exp(bex[16])+exp(bex[17]));
p4=1-p1-p2-p3;
print "prob of mass pt 1= " p1;
print "prob of mass pt 2= " p2;
print "prob of mass pt 3= " p3;
print "prob of mass pt 3= " p4;

/*likelihood*/


proc likexog(theta,dat);
local nrows, fai, j, t, trend, s2u, g, g2, g12, yt, ldv, l2dv,re,
      tsq, tcu, tqu, l12dv , m, tr, pt1, pt2, pt3, pt4,pt5,
      p1, p2,p3, p4,p5, aj, wj;

nrows = rows(dat);

pt1=0;
pt2=theta[12];
pt3=theta[13];
pt4=theta[14];

p1=1/(1+exp(theta[15])+exp(theta[16])+exp(theta[17]));
p2=exp(theta[15])/(1+exp(theta[15])+exp(theta[16])+exp(theta[17]));
p3=exp(theta[16])/(1+exp(theta[15])+exp(theta[16])+exp(theta[17]));
p4=1-p1-p2-p3;

wj=p1~p2~p3~p4;
aj=pt1~pt2~pt3~pt4;

fai = ones(nrows,r1);

j=1;
do while j<=r1;
 re=aj[j];

 g=theta[6]+theta[9]*re;
 g2=theta[7]+theta[10]*re;
 g12=theta[8]+theta[11]*re;
 t=3;
 do while t<=71;
   m=t-2;
   tr=m/10;
   tsq=m*m/1000;
   tcu=m*m*m/100000;
   tqu=m*m*m*m/10000000;
   trend=theta[1]+theta[2]*tr+theta[3]*tsq+theta[4]*tcu
      + theta[5]*tqu;
   yt=dat[.,t];
   ldv=dat[.,t-1];
   l2dv=dat[.,t-2];
   l12dv=ldv.*l2dv;


   fai[.,j] = fai[.,j]
          .*(exp(yt.*(ldv*g+l2dv*g2+g12*l12dv+trend+re))
          ./(1+exp(ldv*g+l2dv*g2+g12*l12dv+trend+re)));
   t=t+1;
  endo;


j=j+1;
endo;



retp( ln( fai*wj') );
endp;



output off;
end;

