/*col5b-- 4mass pts based on m54zrevb */
/* add quad in selection model */
/* interact transition and ret effects, NO elig effects*/
/* interact state dep effects */
/* interact re and quad trend */
/*general selection model*/

new 200,50000;
format /rd 8,4;
outwidth 250;
output file = col5b.out reset;


library  maxlik;
#include maxlik.ext;
maxset;

nobs = 5617;


/*  Load in SSP data: cols 1-38=ia 39=expt2 40=ten 41-46=some xvars */
/*  NOTE in2.dat uses new eligibility date ten */

load temp[] = in54r.dat;
ssp = reshape(temp,nobs,80);
clear temp;

mns=meanc(ssp);

vnames = { "ym1", "y0",
           "y1", "y2", "y3", "y4", "y5", "y6", "y7", "y8", "y9", "y10",
           "y11", "y12", "y13", "y14", "y15", "y16", "y17", "y18", "y19", "y20",
           "y21", "y22", "y23", "y24", "y25", "y26", "y27", "y28", "y29", "y30",
           "y31", "y32", "y33", "y34", "y35", "y36", "y37", "y38", "y39", "y40",
           "y41", "y42", "y43", "y44", "y45", "y46", "y47", "y48", "y49", "y50",
           "y51", "y52", "y53", "y54", "y55", "y56", "y57", "y58", "y59", "y60",
           "y61", "y62", "y63", "y64", "y65", "y66", "y67", "y68", "y69",
           "expt", "ten", "all69", "hsgrad", "basework", "exper", "noexp",
           "agelt25", "premos" }; 
print "means of input data set";
print mns;



r1=4;

	/*  Define variable names in LFP dataset for logit models  */

nobs=rows(ssp);

saved(ssp,"ssp1",vnames);


__maxvec = 600000;


 /* estimation */

_max_CovPar = 2; /*  1=Inv. Hessian; 2=XProduct of Scores; 3=QML */
_mlgrdh = 5e-4;
_mlstep = 5;  /*  Max gradient step */
_max_GradTol = 1e-4; /*  Grad tolerance: default = 1e-5  */
_max_Algorithm=5;

print "covariance matrix choice=" _max_CovPar;
print "1=inv H 2=outer prod 3=qml" ;
print "algorithm=" _max_Algorithm;
print "2=bfgs 3=dfp 5=bhhh";
print "___" ;
print "basic selection mode (5-18 rev) quartic trend";
print "no elig effects, trans+ret effs interacted";
print "state dependence effects interacted";
print "quad trend interacted";
print "4 mass points fully general selection";

clear b0;

b0 = {-1.72, -.502 , 2.18 , -4.961 , 3.506 ,
      4.6  , 1.69, -0.776, -.917, -.544, .63,
       -2.01, .16 , .5675  , -.076,
      -2.82, -1.66, -.109 , -.24,
      -.865, -.465, .35,  -.07,
       -2.30, 2.22, 13.4 ,  .07  , -1.23 , -.36, .60, 1.12 ,
       .016, -.016 };
print "starting values" b0;

p1=1/(1+exp(b0[27])+exp(b0[28])+exp(b0[29]));
p2=exp(b0[27])/(1+exp(b0[27])+exp(b0[28])+exp(b0[29]));
p3=exp(b0[28])/(1+exp(b0[27])+exp(b0[28])+exp(b0[29]));
p4=1-p1-p2-p3;
print "prob of mass pt 1= " p1;
print "prob of mass pt 2= " p2;
print "prob of mass pt 3= " p3;
print "prob of mass pt 4= " p4;

{bex,lex,gex,covex,retex} =
   maxprt( maxlik("ssp1",vnames,&likexog,b0) );
lex = nobs*lex;

print "Maximized log-likelihood= " lex;

p1=1/(1+exp(bex[27])+exp(bex[28])+exp(bex[29]));
p2=exp(bex[27])/(1+exp(bex[27])+exp(bex[28])+exp(bex[29]));
p3=exp(bex[28])/(1+exp(bex[27])+exp(bex[28])+exp(bex[29]));
p4=1-p1-p2-p3;

print "prob of mass pt 1= " p1;
print "prob of mass pt 2= " p2;
print "prob of mass pt 3= " p3;
print "prob of mass pt 4= " p4;


/*likelihood*/


proc likexog(theta,dat);
local nrows, fai, j, s2u, g1, g2, g12,
      yt, ldv, l2dv, l12dv, re, expt, treat,
      t, tr, tsq, tcu, tqu, trend, arg1, ten, dt, pe,
      v1 , m, pt1,pt2,pt3,pt4, p1,p2,p3,p4, aj,wj,
      k1,k2,k3,k4, kj;


nrows = rows(dat);
expt=dat[.,72];

v1=ones(nrows,1);
/* adjust ten by reducing by 1 => 1 mo lag in IA behavior*/
ten=dat[.,73] -v1.*1;

pt1=0;
pt2=theta[24];
pt3=theta[25];
pt4=theta[26];

p1=1/(1+exp(theta[27])+exp(theta[28])+exp(theta[29]));
p2=exp(theta[27])/(1+exp(theta[27])+exp(theta[28])+exp(theta[29]));
p3=exp(theta[28])/(1+exp(theta[27])+exp(theta[28])+exp(theta[29]));
p4=1-p1-p2-p3;

k1=0;
k2=theta[15];
k3=theta[30];
k4=theta[31];

wj=p1~p2~p3~p4;
kj=k1~k2~k3~k4;
aj=pt1~pt2~pt3~pt4;

fai = ones(nrows,r1);

j=1;
do while j<=r1;
 re=aj[j];

 g1=theta[6]+theta[9]*re;
 g2=theta[7]+theta[10]*re;
 g12=theta[8]+theta[11]*re;
 t=3;
 do while t<=71;
   m=t-2;
   tr=m/10;
   tsq=m*m/1000;
   tcu=m*m*m/100000;
   tqu=m*m*m*m/10000000;
   trend=theta[1]+theta[2]*tr+theta[3]*tsq+theta[4]*tcu+theta[5]*tqu
         + theta[32]*re*tr + theta[33]*re*tsq;
   yt=dat[.,t];
   ldv=dat[.,t-1];
   l2dv=dat[.,t-2];
   l12dv=ldv.*l2dv;

  /*treat effects are zero in month 1 */
  /*for ineligs get elig effects months 2-15*/
  /*for eligs get elig effects months 2 - (ten-1)*/
  /*          transitions effs months ten, ten+1, ten+2 */
  /*          ret effs         months ten+3...ten+35    */


   treat =
         (expt.==2 ) .* ( m.>=ten) .* (m.<=(ten+2) ).*
        (  (theta[16]+theta[18]*re).*(ldv.==1)
         + (theta[17]+theta[19]*re).*(ldv.==0)  )

      +  (expt.==2) .* ( m.>=(ten+3)) .*(m.<=(ten+35) ) .*
        (  ( theta[20]+theta[22]*re).*(ldv.==1)
         + ( theta[21]+theta[23]*re).*(ldv.==0)  ) ;

   /* selection argument with 1/m term */
   /* note fix for m=1 to prevent divide by 0 */
   /* pe = 1 for 1st month, earliest move is m=2 */

   dt= theta[12]+theta[13]*(m-1)/10
       + theta[14]/( (m==1)*1 + (m-1) );

   arg1=v1.*(dt- kj[j]);

   pe= (expt.<=0).*v1
    +(expt.>0).*(m==1).*v1
    +(expt.==1).*( (m>=2).*(m<=15).*cdfnc(arg1) + (m>15).*v1  )
    +(expt.==2).*( (m>=2).*(m.<ten).*cdfnc(arg1)
                 + (m.==ten).*cdfn(arg1) + (m.>ten).*v1  );

   fai[.,j] = fai[.,j] .*pe
          .*(exp(yt.*(ldv*g1+l2dv*g2+g12*l12dv+treat+v1.*(re+trend))))
          ./(1+exp(ldv*g1+l2dv*g2+g12*l12dv+treat+v1.*(re+trend)));
   t=t+1;
  endo;


j=j+1;
endo;

retp( ln(fai*wj') );
endp;



output off;
end;

