*coveh- follows relwage1;
*this version tries to adjust for big outliers in earns/hrs;

options ls=140  nocenter nofmterr;

libname ssp '/tmp/ssp/new';
libname here '.';

title1 '54 month data set - wage progression -- IC=1 (5617 sample)';
title2 'those with continuous employment data';

data zero;
set here.wages;
e=1-control;
emonth=j;

oearn=earn;


if hours >0  then cwage=earn/(hours*4.33);
else cwage=.;
ocwage=cwage;
if cwage=. then trim=.; else trim=0;

if cwage ne . then do;
 if cwage<minwage-1 then do;
  if wage>minwage-1 then cwage=wage;
  else cwage=minwage-1;
  earn=hours*4.33*cwage;
  trim=1;
  end;
 if cwage>45 then do;
  if wage > 0 and wage< 45 then cwage=wage;
   else cwage=45;
  earn=hours*4.33*cwage;
  trim=2;
  end;
 end;

relearn=earn/minwage;


if (wage ne .) and (wage<minwage-1) then lowwage=1;
else if (wage ne .) then lowwage=0;
else lowwage=.;

misshrs=(hours=.);
missearn=(hours=.);
misswage=(wage=.);

proc freq;
tables misshrs*e missearn*e misswage*e
       misshrs*misswage;

proc sort;
by e emonth;

proc corr;
var hours earn relearn;
by e emonth;
