*gofnewc1;
*sim of model in m54newc1;

options ls=90 nocenter;
libname here '.';

title1 'fit of newc1 - gofnewc1';

data one;
do i=1 to 27860;

s=exp(1.1214/2);
a=s*rannor(7722117);
yl1=1;
yl2=1;

array ia (*) ia1-ia69;

do t=1 to 69;

tr=-1.3724 - .8512*t/10+ 3.5253*t*t/1000-7.4548*t*t*t/100000
   + 5.1834 *t*t*t*t/10000000;

g1=4.7809-.7436*a;
g2=1.8993-.4015*a;
g12=-.8665+.7623*a;
arg=g1*yl1 + g2*yl2 + g12*yl1*yl2 + a + tr;

cut=exp(arg)/(1+exp(arg));
u=ranuni(5522771);
if u<cut then ia(t)=1;
 else ia(t)=0;

yl1=ia(t);
if t>=2 then yl2=ia(t-1);
end;
output;
keep i ia1-ia69;
end;


proc means;
title2 'controls';
var ia1-ia69;


data two;
set one;

ia0=1;
array ia (*) ia0 ia1-ia69;

sum=0;
ntrans=0;

do j=2 to 70;
sum=sum+ia(j);
if (ia(j) ne ia(j-1)) then ntrans=ntrans+1;
end;


if sum<=2 then sc='a. 0-2   ';
else if sum<=8 then sc='b. 3-8';
else if sum<=14 then sc='c. 9-14';
else if sum<=20 then sc='d. 15-20';
else if sum<=26 then sc='e. 21-26';
else if sum<=32 then sc='f. 27-32';
else if sum<=38 then sc='g. 33-38';
else if sum<=44 then sc='h. 39-44' ;
else if sum<=50 then sc='i. 45-50';
else if sum<=56 then sc='j. 51-56';
else if sum<=62 then sc='k. 57-62';
else if sum<=67 then sc='l. 63-67';
else if sum=68 then sc='m. 68';
else if sum=69 then sc='n. 69';
else sc='screwup';

if ntrans<=2 then nt=ntrans;
else if ntrans>=3 and mod(ntrans,2)=1 then nt=3;
else if ntrans>=4 and mod(ntrans,2) ne 1 then nt=4;
else nt=9;
c=1;

proc freq;
tables sc*nt;

proc summary;
class sc nt;
var c;
output out=fit
sum(c)=nfit;

proc print data=fit
var sc nt nfit;

data act;
set here.gof_act;
if control=1 and sc ne ' ' and nt ne .;
nact=n;
drop n;

proc sort; by nt sc;

data fit2;
set fit ;
if sc ne ' ' and nt ne .;

nfit=nfit/10;
proc sort; by nt sc;

data all;
merge act fit2; by nt sc;

retain gof;

if nact=. then nact=0;
dev=(nact-nfit)**2/nfit ;
gof+dev;

proc print;
var nt sc nact nfit dev gof;

proc means n mean sum;
var dev;



***redo for programs;

data one;
do i=1 to 28310;

s=exp(1.1214/2);
a=s*rannor(7722117);

g1=4.7809-.7436*a;
g2=1.8993-.4015*a;
g12=-.8665+.7623*a;

yl1=1;
yl2=1;

w=ranuni(553311);
if w<.1787 then ten=2;
else if w<.2675 then ten=3;
else if w<.3584 then ten=4;
else if w<.4295 then ten=5;
else if w<.4901 then ten=6;
else if w<.5486 then ten=7;
else if w<.5998 then ten=8;
else if w<.6541 then ten=9 ;
else if w<.7074 then ten=10;
else if w<.7649 then ten=11;
else if w<.8339 then ten=12;
else if w<.8914 then ten=13;
else if w<.9729 then ten=14;
else ten=15;

w2=ranuni(88771155);
if w2<.338043 then elig=1;
else elig=0;

array ia (*) ia1-ia69;

do t=1 to 69;

tr=-1.3724 - .8512*t/10+ 3.5253*t*t/1000-7.4548*t*t*t/100000
   + 5.1834 *t*t*t*t/10000000;
if elig=0 then treat=0;
else if elig=1 and t<ten then treat=0;

else if elig=1 and (t>=ten) and (t<=(ten+2)) then do;
  if yl1=1 then treat=-3.0155;
  else if yl1=0 then treat=-1.9220;
  end;

else if elig=1 and (t>=(ten+3)) and (t<=(ten+35)) then do;
  if yl1=1 then treat=-1.3515;
  else if yl1=0 then treat=-0.8614;
  end;

else if elig=1 and (t>=(ten+36)) then treat=0;

arg=g1*yl1 + g2*yl2 + g12*yl1*yl2 + a + tr + treat;

cut=exp(arg)/(1+exp(arg));
u=ranuni(5644441);
if u<cut then ia(t)=1;
 else ia(t)=0;

yl1=ia(t);
if t>=2 then yl2=ia(t-1);

end;
output;
keep i ia1-ia69 ten elig;
end;


proc means;
title2 'programs - mean IA';
var elig ia1-ia69;

proc means;
where (elig=1);
title2 'elig subset';
var elig ia1-ia69;

proc freq;
where (elig=1);
tables ten;

data two;
set one;

ia0=1;
array ia (*) ia0 ia1-ia69;

sum=0;
ntrans=0;

do j=2 to 70;
sum=sum+ia(j);
if (ia(j) ne ia(j-1)) then ntrans=ntrans+1;
end;


if sum<=2 then sc='a. 0-2   ';
else if sum<=8 then sc='b. 3-8';
else if sum<=14 then sc='c. 9-14';
else if sum<=20 then sc='d. 15-20';
else if sum<=26 then sc='e. 21-26';
else if sum<=32 then sc='f. 27-32';
else if sum<=38 then sc='g. 33-38';
else if sum<=44 then sc='h. 39-44' ;
else if sum<=50 then sc='i. 45-50';
else if sum<=56 then sc='j. 51-56';
else if sum<=62 then sc='k. 57-62';
else if sum<=67 then sc='l. 63-67';
else if sum=68 then sc='m. 68';
else if sum=69 then sc='n. 69';
else sc='screwup';

if ntrans<=2 then nt=ntrans;
else if ntrans>=3 and mod(ntrans,2)=1 then nt=3;
else if ntrans>=4 and mod(ntrans,2) ne 1 then nt=4;
else nt=9;
c=1;

proc freq;
title2 'programs';
tables sc*nt;

proc summary;
class sc nt;
var c;
output out=fit
sum(c)=nfit;

proc print data=fit
var sc nt nfit;

data act;
set here.gof_act;
if control=0 and sc ne ' ' and nt ne .;
nact=n;
drop n;

proc sort; by nt sc;

data fit2;
set fit ;
if sc ne ' ' and nt ne .;

nfit=nfit/10;
proc sort; by nt sc;

data all;
merge act fit2; by nt sc;

retain gof;

if nact=. then nact=0;
dev=(nact-nfit)**2/nfit ;
gof+dev;

proc print;
var nt sc nact nfit dev gof;

proc means n mean sum;
var dev;

