*gof_col4.sas;
*sim of model in m54zrevb;

options ls=90 nocenter;
libname here '.';

title1 'fit of m54zrevb - gof_j6 - quad trend * RE';

data one;
do i=1 to 27860;

s=exp(.3373  /2);
a=s*rannor(7722117);
yl1=1;
yl2=1;

array ia (*) ia1-ia69;

do t=1 to 69;

tr=-1.6097- .5167*t/10+2.2854*t*t/1000-5.5260*t*t*t/100000
   + 4.0811*t*t*t*t/10000000 +.2970*a*t/10
  -.3278*a*t*t/1000;

g1=4.6913-1.1189*a;
g2=1.8370-.4029*a;
g12=-.8237+1.0943*a;

arg=yl1*g1 +yl2*g2 +yl1*yl2*g12  +a+tr;

cut=exp(arg)/(1+exp(arg));
u=ranuni(5522771);
if u<cut then ia(t)=1;
 else ia(t)=0;

yl1=ia(t);
if t>=2 then yl2=ia(t-1);
end;
output;
keep i ia1-ia69;
end;


proc means;
title2 'controls';
var ia1-ia69;


data two;
set one;

ia0=1;
array ia (*) ia0 ia1-ia69;

sum=0;
ntrans=0;

do j=2 to 70;
sum=sum+ia(j);
if (ia(j) ne ia(j-1)) then ntrans=ntrans+1;
end;


if sum<=2 then sc='a. 0-2   ';
else if sum<=8 then sc='b. 3-8';
else if sum<=14 then sc='c. 9-14';
else if sum<=20 then sc='d. 15-20';
else if sum<=26 then sc='e. 21-26';
else if sum<=32 then sc='f. 27-32';
else if sum<=38 then sc='g. 33-38';
else if sum<=44 then sc='h. 39-44' ;
else if sum<=50 then sc='i. 45-50';
else if sum<=56 then sc='j. 51-56';
else if sum<=62 then sc='k. 57-62';
else if sum<=67 then sc='l. 63-67';
else if sum=68 then sc='m. 68';
else if sum=69 then sc='n. 69';
else sc='screwup';

if ntrans<=2 then nt=ntrans;
else if ntrans>=3 and mod(ntrans,2)=1 then nt=3;
else if ntrans>=4 and mod(ntrans,2) ne 1 then nt=4;
else nt=9;
c=1;

proc freq;
tables sc*nt;

proc summary;
class sc nt;
var c;
output out=fit
sum(c)=nfit;

proc print data=fit
var sc nt nfit;

data act;
set here.gof_act;
if control=1 and sc ne ' ' and nt ne .;
nact=n;
drop n;

proc sort; by nt sc;

data fit2;
set fit ;
if sc ne ' ' and nt ne .;

nfit=nfit/10;
proc sort; by nt sc;

data all;
merge act fit2; by nt sc;

retain gof;

if nact=. then nact=0;
dev=(nact-nfit)**2/nfit ;
gof+dev;

proc print;
var nt sc nact nfit dev gof;

proc means n mean sum;
var dev;



***redo for programs;

data one;
do i=1 to 28310;

s=exp( .3373 /2);
a=s*rannor(7753311);
yl1=1;
yl2=1;
ten=.;
el=0;
elig=0;

array ia (*) ia1-ia69;

do t=1 to 69;


tr=-1.6097- .5167*t/10+2.2854*t*t/1000-5.5260*t*t*t/100000
   + 4.0811*t*t*t*t/10000000 +.2970*a*t/10
  -.3278*a*t*t/1000;




dt=-2.2204 +.1826*(t-1)/10 +.5460/( (t=1)+(t-1) );
v=rannor(88221);
arg2=dt- .2873  *a;

if el=0 and (v<=arg2) and (2<=t<=15) then do;
 elig=1;
 ten=t;
end;
else if el=0 then elig=0;
else if el=1 then elig=1;

if t=1 then treat=0;

else if elig=0 and (t>=2) and (t<=15) then do;
  if yl1=1 then treat=0;
  else if yl1=0 then treat=0;
  end;
else if elig=0 and (t>=16) then treat=0;

else if elig=1 and (t>=ten) and (t<=(ten+2)) then do;
  if yl1=1 then treat=-3.1016-.6148*a;
  else if yl1=0 then treat=-1.7454-.2173*a;
  end;

else if elig=1 and (t>=(ten+3)) and (t<=(ten+35)) then do;
  if yl1=1 then treat=-1.1148-.0655*a;
  else if yl1=0 then treat=-0.7155-.3516*a;
  end;


else if elig=1 and (t>=(ten+36)) then treat=0;


g1=4.6913-1.1189*a;
g2=1.8370-.4029*a;
g12=-.823722+1.0943*a;


arg=yl1*g1 +yl2*g2 +yl1*yl2*g12  +a+tr +treat;

cut=exp(arg)/(1+exp(arg));
u=ranuni(5644441);
if u<cut then ia(t)=1;
 else ia(t)=0;

yl1=ia(t);
if t>=2 then yl2=ia(t-1);
el=elig;

end;
output;
keep i ia1-ia69 ten elig;
end;


proc means;
title2 'programs - mean IA';
var elig ia1-ia69;

proc means;
where (elig=1);
title2 'elig subset';
var elig ia1-ia69;

proc means;
where (elig=0);
title2 'inelig subset';
var elig ia1-ia69;

proc freq;
where (elig=1);
tables ten;

data two;
set one;

ia0=1;
array ia (*) ia0 ia1-ia69;

sum=0;
ntrans=0;

do j=2 to 70;
sum=sum+ia(j);
if (ia(j) ne ia(j-1)) then ntrans=ntrans+1;
end;


if sum<=2 then sc='a. 0-2   ';
else if sum<=8 then sc='b. 3-8';
else if sum<=14 then sc='c. 9-14';
else if sum<=20 then sc='d. 15-20';
else if sum<=26 then sc='e. 21-26';
else if sum<=32 then sc='f. 27-32';
else if sum<=38 then sc='g. 33-38';
else if sum<=44 then sc='h. 39-44' ;
else if sum<=50 then sc='i. 45-50';
else if sum<=56 then sc='j. 51-56';
else if sum<=62 then sc='k. 57-62';
else if sum<=67 then sc='l. 63-67';
else if sum=68 then sc='m. 68';
else if sum=69 then sc='n. 69';
else sc='screwup';

if ntrans<=2 then nt=ntrans;
else if ntrans>=3 and mod(ntrans,2)=1 then nt=3;
else if ntrans>=4 and mod(ntrans,2) ne 1 then nt=4;
else nt=9;
c=1;

proc freq;
title2 'programs';
tables sc*nt;

proc summary;
class sc nt;
var c;
output out=fit
sum(c)=nfit;

proc print data=fit
var sc nt nfit;

data act;
set here.gof_act;
if control=0 and sc ne ' ' and nt ne .;
nact=n;
drop n;

proc sort; by nt sc;

data fit2;
set fit ;
if sc ne ' ' and nt ne .;

nfit=nfit/10;
proc sort; by nt sc;

data all;
merge act fit2; by nt sc;

retain gof;

if nact=. then nact=0;
dev=(nact-nfit)**2/nfit ;
gof+dev;

proc print;
var nt sc nact nfit dev gof;

proc means n mean sum;
var dev;


