*prog0: revised dec 03;


title1 'ssp data set';

options ls=120 nocenter nofmterr;

libname oldssp '/tmp/ssp/old';
libname newssp '/tmp/ssp/new';


data one;
set oldssp.y54c1510 (keep=idresgrp idprov inplus in18m in36mo
    in54mo tkupdate
    basintdt bfemale
    bkid02 bkid34 bkid5 bkid69 bkid1012 bkid1315 bkid1618 btotkds
    oniam1-oniam80 oniapm1-oniapm36 onsum1-onsum65
    emplm1-emplm54 emplpm1 emplpm2
    wagem1-wagem54 wagepm1 wagepm2  earnm1-earnm54 earnpm1 earnpm2
    emftpm1 emftpm2  emftm1-emftm54
    hrswm1-hrswm54 hrswpm1 hrswpm2
    bnvrmar bexptmar blths bd8
    brealage btotkds bseparat bdivorce bwidowed
    bmomdad biahistr bpaidwor bempyrs bbasewor bbaseloo benrolle
    bownhome bsubshom bphyspro bemotpro beuropea basian bfirstna bbornher
    kiapm36 blikewrk );

if idresgrp ne '+';


kidslt6=bkid02+bkid34+bkid5;
anylt6=(kidslt6>0);
kids615=bkid69+bkid1012+bkid1315;
kidslt16 = kidslt6+kids615;

div_sep=bseparat+bdivorce;
nevermar=(bnvrmar=100);
imm=(bbornher=0);
asian=(basian=100);

physprob=(bphyspro=100);
emotprob=(bemotpro=100);
drop bphyspro bemotpro;

basework=(bbasewor=100);
baselook=(bbaseloo=1);
if basework=1 then baselook=0;
drop bbasewor bbaseloo;


bc=(idprov='BC');
control=(idresgrp = 'C');
drop idprov idresgrp;

age=brealage;
if age<19 then age=19;
if age>65 then age=65;
drop brealage;

hsgrad=(blths=0);


ownhome=(bownhome=1);
likework=(blikewrk=1);
momdad=(bmomdad=1);
native=(bfirstna=100);
higrad=bd8;
if higrad<0 or higrad>16 then higrad=8;
male=(bfemale=0);

drop blths bownhome blikewrk bfirstna
     bd8 bfemale;


famwelf=(biahistr=100);
exp=bempyrs;


array preia (*) oniapm1-oniapm36;
premos=0;
do j=1 to 36;
premos=premos+preia(j);
end;
if premos=. then premos=30;  /*assign 1 obs with missing*/


cumexp=0;
array emp (*) emplm1-emplm53;
do j=1 to 53;
cumexp=cumexp+emp(j);
end;


length  bc control physprob emotprob male
    kidslt6 anylt6 kids615 kidslt16 div_sep nevermar momdad imm
    asian native hsgrad higrad age baselook basework
    likework ownhome bemotpro kiapm36
    famwelf exp
    oniam1-oniam65 oniapm1-oniapm2  onsum1-onsum65
    emplm1-emplm54 bfemale emplpm1 emplpm2
    emftpm1 emftpm2  emftm1-emftm54 3 ;


label kidslt6='# kids under 6'
      anylt6='1 if any kids uner 6'
      kids615='#kids 6-15'
      kidslt16='#kids under 16'
      ownhome='1 if own home'
      likework='1 if like to work'
      momdad='1 if lived w/ mom+dad at 16'
      native='1 if first nation'
      div_sep='1 if divorced/sep'
      emotprob='1 if emotional prob'
      physprob='1 if phys prob'
      imm='1 if immigrant'
      basework='1 if working at base'
      baselook='1 if looking for work at base'
      bc='1 if in bc'
      control='1 if control/0=exp'
      hsgrad='1 if hs grad'
      age='age (brealage)'
      nevermar='1 if never married'
      higrad='highest grade (bd8)'
      premos='num months on ia, pm1-36'
      famwelf='mom got welfare (iahistr)'
      exp='yrs work experience';



lowed=(higrad<8);
label lowed='1 if under 8 yrs ed';

if exp>30 then exp=30;
if exp<0 then exp=age-higrad-7;
if exp<0 then exp=0;
noexp=(exp=0);
label noexp='no work exp';

**** define ic;
if oniapm1=1 and oniam1=1 then ic=1;
else ic=0;
label ic='1 if initial conditions ok';


**define eversup;
array sup (65) onsum1-onsum65;
eversup=0;
do j=1 to 65;
 if sup(j)=1 then eversup=1;
end;
label eversup = '1 if ever supp check mos 1-65';

**define 3 expt groups;
if control=1 then expt=0;
 else if eversup=0 then expt=1;
 else expt=2;
label expt='0=c 1=e, no sup 2=e, get sup';


*align as per dean program ercgauss2;
array ia (95) oniam2-oniam96;
array su (36) onsum1-onsum36;
array ft (36) emftm1-emftm36;


*define first month off ia, on supplement,and in ft work;
m1_ia=37;
m1_su=37;
m1_ft=37;
m1_ia2=37;

mo_sup=0;
mo_ft=0;

do j=1 to 36;
 if ia(j)=0 and j<m1_ia then m1_ia=j;
 if j>=2 and ia(j)=0 and ia(j-1)=0 and (j-1)<m1_ia2 then m1_ia2=j-1;
 if su(j)=1 and j<m1_su then m1_su=j;
 if ft(j)=1 and j<m1_ft then m1_ft=j;
 if su(j)=1 then mo_sup=mo_sup+1;
 if ft(j)=1 then mo_ft =mo_ft +1;
 end;

*deans code for te, denoting split between eligibility/retention;
v1=m1_su-1;
v2=max(m1_ia, m1_ft);
te=min(14,v1,v2);
te2=te+2;
ten=min(14,v1,m1_ft)+2;

*overwrite for controls and non-suppl receivers;
if expt=0 then do;
 te=0;
 te2=0;
 ten=0;
end;
else if expt=1 then do;
 te=14;
 te2=16;
 ten=16;
end;

label m1_ia='1st mo off ia'
         te='ssp mo (dean defn)'
         te2='ssp mo+2 (dean defn)'
         ten='ssp mo+2--new defn' ;

*construct re-normalized ia var;
length ia1-ia95 3;
array iar (*) ia1-ia95;
do j=1 to 95;
 iar(j)=ia(j);
end;



proc sort;
by control;

proc means;
by control;

proc freq;
tables ten  / missing;


data newssp.newprog1r;
set one;
if ic=1;


proc means;
title2 'exclude those not on ia in months -1 and 1';
by control;

