*relwage1- follows prog0, using newprog1r;
*looks at wage relative to minwage;


options ls=90  nocenter nofmterr;

libname ssp '/tmp/ssp/new';
libname here '.';

title1 '54 month data set - wage progression -- IC=1 (5617 sample)';
title2 'those with continuous employment data';

data one;
set ssp.newprog1r;
id=_n_;

if cumexp ne .;

if in18m=1 and in36mo=1 and in54mo=1 then
 allint=1;
else allint=0;


*define pre-baseline wage;
if wagepm1>0 or wagepm2>0 then havepre=1;
else havepre=0;

if havepre=1 then do;
 if wagepm1>0 then wagepre=wagepm1;
 else wagepre=wagepm2;
end;

twagepre=wagepre;
if wagepre>0 then do;
 if wagepre<3.5 then twagepre=3.5;
 if wagepre>45  then twagepre=45;
end;



array yr (*) yr1-yr53;
array mo (*) mo1-mo53;
array cdate (*) cdate1-cdate53;
array minw  (*) minw1-minw53;


*Get dating and min wage information;

bintyr=year(basintdt);
bintmo=month(basintdt);

yr1=bintyr;
mo1=bintmo;

do j=2 to 53;
 if mo(j-1)<12 then do;
   mo(j)=mo(j-1)+1;
   yr(j)=yr(j-1);
   end;
 else do;
   mo(j)=1;
   yr(j)=yr(j-1)+1;
   end;
 end;

do j=1 to 53;
 cdate(j)=mdy(mo(j),15,yr(j));
 if bc=1 then do;
  if cdate(j)<mdy(3,1,95) then minw(j)=6;
   else if cdate(j)<mdy(10,1,95) then minw(j)=6.5;
   else if cdate(j)<mdy(4,1,98) then minw(j)=7.0;
   else if cdate(j)<mdy(11,1,2000) then minw(j)=7.15;
   else if cdate(j)<mdy(11,1,2001) then minw(j)=7.60;
   else minw(j)=8.00;
  end;
 else if bc=0 then do;
  if cdate(j)<mdy(1,1,96) then minw(j)=5;
   else if cdate(j)<mdy(7,1,96) then minw(j)=5.25;
   else if cdate(j)<mdy(1,1,2000) then minw(j)=5.50;
   else if cdate(j)<mdy(7,1,2001) then minw(j)=5.75;
   else minw(j)=5.90;
  end;
 end;

if mo1=1 then do;
 mo0=12;
 yr0=yr1-1;
 end;
else do;
 mo0=mo1-1;
 yr0=yr1;
 end;


array w (*) wagem1-wagem53;
array em (*) emplm1-emplm53;
array eft (*) emftm1-emftm53;
array er (*) earnm1-earnm53;
array onia (*) ia1-ia53;  /*already readjusted time*/
array sup (*) onsum1-onsum53;
array wtrim (*) wtrim1-wtrim53;
array logw (*) lw1-lw53;
array relw (*) relw1-relw53;


e=1-control;
id=_n_;
elig=eversup;

do j=1 to 53;
 minwage=minw(j);
 wage=w(j);
 wtrim(j)=wage;
 if wage>0 and wage<.8*minwage then do;
  wtrim(j)=.8*minwage;
  end;
 if wage> 6*minwage then do;
  wtrim(j)=6*minwage;
  end;
 if wtrim(j) >0 then logw(j)=log(wtrim(j));
 if wage>0 then relw(j)=wage-minwage;
 else relw(j)=.;
end;



nb=1-bc;
if mo53 in (1,2,3) then q53=1;
 else if mo53 in (4,5,6) then q53=2;
 else if mo53 in (7,8,9) then q53=3;
 else q53=4;

trend53=(yr53-1997)*12+mo53;
tr_nb=trend53*nb;
tr_bc=trend53*bc;

gotwage53=(wagem53>0);
yr97=(yr53=1997);
yr98=(yr53=1998);
yr99=(yr53=1999);
under30=(age<30);
bw_nb=basework*nb;

nb_97=yr97*nb;
nb_98=yr98*nb;
nb_99=yr99*nb;
bc_97=yr97*bc;
bc_98=yr98*bc;
bc_99=yr99*bc;
q1=(q53=1);
q2=(q53=2);
q3=(q53=3);
q4=(q53=4);
q1_nb=q1*nb;
q2_nb=q2*nb;
q3_nb=q3*nb;
q4_nb=q4*nb;
bw_age=basework*age;
bw_exp=basework*exp;
bw_hs=basework*hsgrad;
bw_nb=basework*nb;
bw_kids=basework*kidslt6;
gotw2=1-gotwage53;

*code from ps53b;
index= 1.0166 +
nb          *   0.2354 + 
tr_nb       *   0.0172 + 
tr_bc       *   0.0261 + 
basework    *   0.4661 + 
baselook    *   0.1805 + 
likework    *   0.2652 + 
native      *  -0.2445 + 
anylt6      *  -0.1798 + 
kidslt6     *  -0.3305 + 
premos      *  -0.0133 + 
hsgrad      *   0.5503 + 
higrad      *   0.0494 + 
exp         *   0.0698 + 
age         *  -0.0839 + 
under30     *  -0.1208 + 
imm         *  -0.3025 + 
nevermar    *   0.0515 + 
physprob    *  -0.5503 + 
emotprob    *  -0.3477 + 
male        *  -1.0057 + 
momdad      *   0.1108 + 
famwelf     *  -0.1986 + 
bw_age      *   0.0285 + 
bw_hs       *  -0.9300 + 
bw_nb       *   0.1477 ;

prob53=exp(index)/(1+exp(index));


proc freq;
tables bc*minw53
       bc*minw53;

proc means n mean std stderr min max;
where (e=0);
var bc gotwage53 wagem53 minw53 relw53 wtrim53 lw53 ;

proc means n mean std stderr min max;
where (e=1);
var bc gotwage53 wagem53 minw53 relw53 wtrim53 lw53 ;


data here.wages;
set one;

array w (*) wagem1-wagem53;
array em (*) emplm1-emplm53;
array eft (*) emftm1-emftm53;
array er (*) earnm1-earnm53;
array onia (*) ia1-ia53;  /*already readjusted time*/
array sup (*) onsum1-onsum53;
array wtrim (*) wtrim1-wtrim53;
array logw (*) lw1-lw53;
array relw (*) relw1-relw53;
array yr (*) yr1-yr53;
array mo (*) mo1-mo53;
array cdate (*) cdate1-cdate53;
array minw  (*) minw1-minw53;
array hrs (*) hrswm1-hrswm53;

do j=1 to 53;
 wage=w(j);
 gotwage=(wage ne .);
 minwage=minw(j);
 emp=em(j);
 twage=wtrim(j);
 year=yr(j);
 month=mo(j);
 ia=onia(j);
 ssp=sup(j);
 fulltime=eft(j);
 earn=er(j);
 hours=hrs(j);
 keep j id control elig bc year month emp gotwage wage twage
      ia ssp fulltime earn wagepm1 wagepm2 havepre wagepre
      minwage hours
      mo0 yr0 min0 basework age hsgrad  ;
output;
end;

proc freq;
tables j control*elig bc year month ;

proc means;

