*relwage3- follows relwage1;


options ls=140  nocenter nofmterr;

libname ssp '/tmp/ssp/new';
libname here '.';

title1 '54 month data set - wage progression -- IC=1 (5617 sample)';
title2 'those with continuous employment data';

data zero;
set here.wages;
e=1-control;
emonth=j;

proc summary;
var gotwage ;
class e emonth;
output out=int
n(gotwage)=ntot
sum(gotwage)=nwage
mean(gotwage)=fwage;

data int2;
set int;
if e ne . and emonth ne .;
keep e emonth ntot nwage fwage;

proc sort data=int2; by e emonth;

proc print;
var e emonth ntot nwage fwage;

proc sort data =zero; by e emonth;


data one;
merge zero int2; by e emonth;

if wage=. then wc=0;
else if wage<minwage-1  then wc=1;
else if wage<minwage-.25 then wc=2;
else if wage<minwage+.25 then wc=3;
else if wage<minwage+1     then wc=4;
else if wage<minwage+2     then wc=5;
else if wage<minwage+3     then wc=6;
else if wage<minwage+5     then wc=7;
else if wage<minwage+7     then wc=8;
else if wage<minwage+10    then wc=9;
else  wc=10;
c=1;

array wclass (*) w0-w10;
do j=1 to 11;
if wc=j-1 then wclass(j)=1; else wclass(j)=0;
end;

relearn=earn/minwage;


proc freq;
tables wc*e;

proc summary;
class e emonth;
var ntot nwage fwage w0-w10 earn hours relearn;
output out=here.sumw
mean=;

data a;
set here.sumw;

if e ne . and emonth ne .;

array w (*) w1-w10;
array wc (*) wc1-wc10;

do j=1 to 10;
wc(j)=w(j)/fwage;
end;
proc corr;
var fwage w0;


proc print;
var e emonth ntot fwage w0-w10;
format fwage w0-w10 7.4;

proc print;
var e emonth earn hours relearn;


proc print;
var e emonth ntot fwage wc1-wc10;
format fwage wc1-wc10 7.4;

data b1;
set a;
if e=0;
array cw (*) cw0-cw10;
array w (*) w0-w10;
do j=1 to 11;
cw(j)=w(j);
end;
cearn=earn;
chours=hours;
crelearn=relearn;
keep emonth cw0-cw10 cearn chours crelearn;

data b2;
set a;
if e=1;
array ew (*) ew0-ew10;
array w (*) w0-w10;
do j=1 to 11;
ew(j)=w(j);
end;
eearn=earn;
ehours=hours;
erelearn=relearn;
keep emonth ew0-ew10 eearn ehours erelearn;

proc sort data=b1; by emonth;
proc sort data=b2; by emonth;

data c;
merge b1 b2; by emonth;

array ew (*) ew0-ew10;
array cw (*) cw0-cw10;
array excess (*) excess0-excess10;
array exshr  (*) exshr0-exshr10;

gain=cw0-ew0;
dearn=eearn-cearn;
drelearn=erelearn-crelearn;
dhours=(ehours-chours)*4.33;
mwage=dearn/dhours;
mwager=drelearn/dhours;


do j=1 to 11;
excess(j)=ew(j)-cw(j);
end;

do j=2 to 11;
exshr(j)=(ew(j)-cw(j))/(cw0-ew0);
end;

proc print;
var emonth excess0-excess10;
format excess0-excess10 f7.4;

proc print;
var emonth exshr1-exshr10;
format exshr1-exshr10 f7.4;

proc print;
var emonth gain excess3 excess4 excess5 mwage mwager;
