*relwage3- follows relwage1;
*this version tries to adjust for big outliers in earns/hrs;

options ls=140  nocenter nofmterr;

libname ssp '/tmp/ssp/new';
libname here '.';

title1 '54 month data set - wage progression -- IC=1 (5617 sample)';
title2 'those with continuous employment data';

data zero;
set here.wages;
e=1-control;
emonth=j;

proc summary;
var gotwage ;
class e emonth;
output out=int
n(gotwage)=ntot
sum(gotwage)=nwage
mean(gotwage)=fwage;

data int2;
set int;
if e ne . and emonth ne .;
keep e emonth ntot nwage fwage;

proc sort data=int2; by e emonth;

proc print;
var e emonth ntot nwage fwage;

proc sort data =zero; by e emonth;


data one;
merge zero int2; by e emonth;

if wage=. then wc=0;
else if wage<minwage-1  then wc=1;
else if wage<minwage-.25 then wc=2;
else if wage<minwage+.25 then wc=3;
else if wage<minwage+1     then wc=4;
else if wage<minwage+2     then wc=5;
else if wage<minwage+3     then wc=6;
else if wage<minwage+5     then wc=7;
else if wage<minwage+7     then wc=8;
else if wage<minwage+10    then wc=9;
else  wc=10;
c=1;

array wclass (*) w0-w10;
do j=1 to 11;
if wc=j-1 then wclass(j)=1; else wclass(j)=0;
end;


oearn=earn;


if hours ne . then cwage=earn/(hours*4.33);
else cwage=.;
ocwage=cwage;
if cwage=. then trim=.; else trim=0;

if cwage ne . then do;
 if cwage<minwage-1 then do;
  if wage>minwage-1 then cwage=wage;
  else cwage=minwage-1;
  earn=hours*4.33*cwage;
  trim=1;
  end;
 if cwage>45 then do;
  if wage > 0 and wage< 45 then cwage=wage;
   else cwage=45;
  earn=hours*4.33*cwage;
  trim=2;
  end;
 end;

relearn=earn/minwage;


if (wage ne .) and (wage<minwage-1) then lowwage=1;
else if (wage ne .) then lowwage=0;
else lowwage=.;


proc freq;
tables wc*e trim*e trim*lowwage ;

proc corr;
var wage cwage ocwage;

proc corr;
where trim=1;
var cwage ocwage wage oearn earn hours;

proc corr;
where trim=2;
var cwage ocwage wage oearn earn hours;

proc corr;
where trim=0 and wage ne .;
var cwage ocwage wage oearn earn hours;


proc summary;
class e emonth;
var ntot nwage fwage w0-w10 earn hours relearn;
output out=here.sumw
mean=
stderr(earn)=see
stderr(hours)=seh
stderr(relearn)=ser;

data a;
set here.sumw;

if e ne . and emonth ne .;

array w (*) w1-w10;
array wc (*) wc1-wc10;

do j=1 to 10;
wc(j)=w(j)/fwage;
end;
proc corr;
var fwage w0;


proc print;
var e emonth ntot fwage w0-w10;
format fwage w0-w10 7.4;

proc print;
var e emonth earn hours relearn;


proc print;
var e emonth ntot fwage wc1-wc10;
format fwage wc1-wc10 7.4;

data b1;
set a;
if e=0;
array cw (*) cw0-cw10;
array w (*) w0-w10;
do j=1 to 11;
cw(j)=w(j);
end;
cearn=earn;
chours=hours;
crelearn=relearn;
seec=see;
sehc=seh;
serc=ser;

keep emonth cw0-cw10 cearn chours crelearn
     seec sehc serc;
data b2;
set a;
if e=1;
array ew (*) ew0-ew10;
array w (*) w0-w10;
do j=1 to 11;
ew(j)=w(j);
end;
eearn=earn;
ehours=hours;
erelearn=relearn;
seee=see;
sehe=seh;
sere=ser;
keep emonth ew0-ew10 eearn ehours erelearn
     seee sehe sere;
proc sort data=b1; by emonth;
proc sort data=b2; by emonth;

data c;
merge b1 b2; by emonth;

array ew (*) ew0-ew10;
array cw (*) cw0-cw10;
array excess (*) excess0-excess10;
array exshr  (*) exshr0-exshr10;

gain=cw0-ew0;
dearn=eearn-cearn;
drelearn=erelearn-crelearn;
dhours=(ehours-chours)*4.33;

mwage=dearn/dhours;
mwager=drelearn/dhours;

vep=seee**2;
vhp=sehe**2;
cp=.85*seee*sehe;
vec=seec**2;
vhc=sehc**2;
cc=.85*seec*sehc;

n=dearn;
d=dhours;
f1=1/d; f2=-n/d**2; f3=-1/d; f4=n/d**2;

v1=f1**2*vep+f2**2*vhp+2*f1*f2*cp
  +f3**2*vec+f4**2*vhc+2*f3*f4*cc;

vep=sere**2;
vhp=sehe**2;
cp=.85*sere*sehe;
vec=serc**2;
vhc=sehc**2;
cc=.85*serc*sehc;

n=drelearn;
d=dhours;
f1=1/d; f2=-n/d**2; f3=-1/d; f4=n/d**2;

v2=f1**2*vep+f2**2*vhp+2*f1*f2*cp
  +f3**2*vec+f4**2*vhc+2*f3*f4*cc;

se1=sqrt(v1);
se2=sqrt(v2);

do j=1 to 11;
excess(j)=ew(j)-cw(j);
end;

do j=2 to 11;
exshr(j)=(ew(j)-cw(j))/(cw0-ew0);
end;

proc print;
var emonth dearn dhours mwage seee sehe seec sehc;
format dearn dhours mwage seee sehe seec sehc 7.3;

proc print;
var emonth drelearn dhours mwager sere sehe serc sehc;
format dearn dhours mwage seee sehe seec sehc 7.3;

proc print;
var emonth mwage se1 mwager se2;
