*sctestc2 - test serial correlation -- controls only;
*using normal model in col 2 new table3 -- from stata;

options ls=110 nocenter nofmterr;

libname ssp '/tmp/ssp/old';
libname here '.';

title1 'ssp 54 data set';


data one;
set ssp.wide54 (keep=ia1-ia69 control bc);
if control=1;
data two;
set one;

*draw from normal and then
 assign likelihood at each mass point;

ia0=1;
iam1=1;

array ia (*) iam1 ia0 ia1-ia69;
array ll (*) ll1-ll10;
array a (*) a1-a10;

sigma=1.322635;

nmass=10;

do m=1 to nmass; /*loop over mass pts*/
a(m)=sigma*rannor(22887711);

g1=5.194518;
g2=2.190008;
g12=-1.394051;

ll(m)=1;
do c=3 to 71;  /*loop over time*/
 t=c-2;
 tr=-1.339677  - .895881 *t/10+2.905683*t*t/1000-5.236169*t*t*t/100000
   + 3.294744 *t*t*t*t/10000000;
 arg=ia(c-1)*g1 +ia(c-2)*g2 +ia(c-1)*ia(c-2)*g12 +a(m)+tr;
 p=exp(ia(c)*arg) / (1+exp(arg));
 ll(m)=ll(m)*p ;
end; /*end of time loop*/

end; /*end of loop over mass pts*/


keep nmass sigma ia1-ia69 a1-a10 ll1-ll10;

proc means;
var sigma ll1-ll10;


data three;
set two;
id=_n_;

ia0=1;
iam1=1;
array ia (*) iam1 ia0 ia1-ia69;
array iap (*) iam1 ia0 iap1-iap69;
array res (*) iam1 ia0 res1-res69;


array a (*) a1-a10;
array ll (*) ll1-ll10;

denom=0;
do j=1 to nmass;
 denom=denom+ ll(j);
end;


do m=1 to nmass;  /*replication loop*/

wt=ll(m)/denom;

g1=5.194518;
g2=2.190008;
g12=-1.394051;

do c=3 to 71;  /*loop over time*/
t=c-2;
 tr=-1.339677  - .895881 *t/10+2.905683*t*t/1000-5.236169*t*t*t/100000
   + 3.294744 *t*t*t*t/10000000;
arg=ia(c-1)*g1 +ia(c-2)*g2 +ia(c-1)*ia(c-2)*g12 +a(m) + tr;
iap(c)=exp(arg)/(1+exp(arg));
res(c)=(ia(c)-iap(c))/sqrt(iap(c)*(1-iap(c)));
re=a(m);
end;

output;
end;


proc means;
var re g1 g2 g12 ia1-ia69;

proc means;
var re g1 g2 g12 iap1-iap69;
weight wt;


data four;
set three;
dummy1=0;
dummy2=0;

array res (*) res1-res69;
c1=0;
c2=0;
c3=0;
c4=0;
c5=0;
m0=0;
s0=0;

do j=1 to 69;
  s0=s0+res(j)**2;
  m0=m0+res(j);
end;

do j=2 to 69;
  c1=c1+res(j)*res(j-1);
end;

do j=3 to 69;
  c2=c2+res(j)*res(j-2);
end;

do j=4 to 69;
  c3=c3+res(j)*res(j-3);
end;

do j=5 to 69;
  c4=c4+res(j)*res(j-4);
end;
do j=6 to 69;
  c5=c5+res(j)*res(j-5);
end;



m0=m0/69;
s0=s0/69;

c1=c1/68;
c2=c2/67;
c3=c3/66;
c4=c4/65;
c5=c5/64;


proc means n mean std stderr min max;
title2 'unwtd';
var m0 s0 c1-c5 wt;


proc means n mean std stderr min max;
title2 'wtd';
var m0 s0 c1-c5;
weight wt;

