*sctest4pt   - test serial correlation -- controls only;
*using 4 mass pt model in cnew10;

options ls=110 nocenter nofmterr;

libname ssp '/tmp/ssp/old';
libname here '.';

title1 'ssp 54 data set';


data one;
set ssp.wide54 (keep=ia1-ia69 control bc);
if control=1;
array ia (*) ia1-ia69;
non=0;
do j=1 to 69;
 non=non+ia(j);
end;

proc freq;
tables non;

data two;
set one;

*assign likelihood at each mass point;

ia0=1;
iam1=1;
array ia (*) iam1 ia0 ia1-ia69;
array ll (*) ll1-ll5;

nmass=4;

do m=1 to nmass; /*loop over mass pts*/

if m=1 then a=0;
else if m=2 then a=-2.2557;
else if m=3 then a= 2.2670;
else if m=4 then a=27.2483;

g1=4.6523-.9303*a;
g2=1.8428-.5751*a;
g12=-.8706+.6053*a;

ll(m)=1;
do c=3 to 71;  /*loop over time*/
 t=c-2;
 tr=-1.9950  -.4084 *t/10+1.59091 *t*t/1000-3.1804*t*t*t/100000
   + 2.0841 *t*t*t*t/10000000;
 arg=ia(c-1)*g1 +ia(c-2)*g2 +ia(c-1)*ia(c-2)*g12 +a + tr;
 p=exp(ia(c)*arg) / (1+exp(arg));
 ll(m)=ll(m)*p ;
end; /*end of time loop*/

end; /*end of loop over mass pts*/


keep nmass ia1-ia69 non ll1-ll5;

proc means;
var non ll1-ll5;
proc means;
where (non=69);
var non ll1-ll5;





data three;
set two;

id=_n_;

ia0=1;
iam1=1;
array ia (*) iam1 ia0 ia1-ia69;
array iap (*) iam1 ia0 iap1-iap69;
array res (*) iam1 ia0 res1-res69;

pi1=.2995;
pi2=.3562;
pi3=.0804;
pi4=.2638;

array pi (*) pi1-pi5;
array ll (*) ll1-ll5;
array ppi (*) ppi1-ppi5;

denom=0;
do j=1 to nmass;
 denom=denom+ pi(j)*ll(j);
end;

do j=1 to nmass;
 ppi(j)=pi(j)*ll(j)/denom;
end;

do i=1 to nmass;  /*replication loop*/


if i=1 then a=0;
else if i=2 then a=-2.2557;
else if i=3 then a= 2.2670;
else if i=4 then a=27.2483;

g1=4.6523-.9303*a;
g2=1.8428-.5751*a;
g12=-.8706+.6053*a;

do c=3 to 71;  /*loop over time*/
t=c-2;
 tr=-1.9950  -.4084 *t/10+1.59091 *t*t/1000-3.1804*t*t*t/100000
   + 2.0841 *t*t*t*t/10000000;
arg=ia(c-1)*g1 +ia(c-2)*g2 +ia(c-1)*ia(c-2)*g12 +a + tr;
iap(c)=exp(arg)/(1+exp(arg));
res(c)=(ia(c)-iap(c))/sqrt( iap(c)*(1-iap(c)) );
end;
wt=ppi(i);

output;
end;


proc means;
var g1 g2 g12 a ia1-ia69 iap1-iap69 wt;
weight wt;


data four;
set three;
dummy1=0;
dummy2=0;

array res (*) res1-res69;
c1=0;
c2=0;
c3=0;
c4=0;
c5=0;
m0=0;
s0=0;

do j=1 to 69;
  s0=s0+res(j)**2;
  m0=m0+res(j);
end;

do j=2 to 69;
  c1=c1+res(j)*res(j-1);
end;

do j=3 to 69;
  c2=c2+res(j)*res(j-2);
end;

do j=4 to 69;
  c3=c3+res(j)*res(j-3);
end;

do j=5 to 69;
  c4=c4+res(j)*res(j-4);
end;

do j=6 to 69;
  c5=c5+res(j)*res(j-5);
end;



m0=m0/69;


s0=s0/69;

c1=c1/68;
c2=c2/67;
c3=c3/66;
c4=c4/65;
c5=c5/64;


test=c1**2+c2**2+c3**2+c4**2+c5**2;

toolow=(wt<.000001);

data a1;
set four;
if i=1;
m0_1=m0;
s0_1=s0;
c1_1=c1;
c2_1=c2;
c3_1=c3;
c4_1=c4;
c5_1=c5;
wt_1=wt;
keep id m0_1 s0_1 c1_1 c2_1 c3_1 c4_1 c5_1 wt_1;
proc sort data =a1; by id;

data a2;
set four;
if i=2;
m0_2=m0;
s0_2=s0;
c1_2=c1;
c2_2=c2;
c3_2=c3;
c4_2=c4;
c5_2=c5;
wt_2=wt;
keep id m0_2 s0_2 c1_2 c2_2 c3_2 c4_2 c5_2 wt_2;
proc sort data =a2; by id;

data a3;
set four;
if i=3;
m0_3=m0;
s0_3=s0;
c1_3=c1;
c2_3=c2;
c3_3=c3;
c4_3=c4;
c5_3=c5;
wt_3=wt;
keep id m0_3 s0_3 c1_3 c2_3 c3_3 c4_3 c5_3 wt_3;
proc sort data =a3; by id;

data a4;
set four;
if i=4;
m0_4=m0;
s0_4=s0;
c1_4=c1;
c2_4=c2;
c3_4=c3;
c4_4=c4;
c5_4=c5;
wt_4=wt;
keep id m0_4 s0_4 c1_4 c2_4 c3_4 c4_4 c5_4 wt_4;
proc sort data =a4; by id;



data g;
merge a1 a2 a3 a4;
by id;

s=s0_1*wt_1+s0_2*wt_2+s0_3*wt_3+s0_4*wt_4;
s2=s0_1*.2995+s0_2*.3562+s0_3*.0804+s0_4*.2638;
w=wt_1+wt_2+wt_3+wt_4;
c1=c1_1*wt_1+c1_2*wt_2+c1_3*wt_3+c1_4*wt_4;
c2=c2_1*wt_1+c2_2*wt_2+c2_3*wt_3+c2_4*wt_4;
c3=c3_1*wt_1+c3_2*wt_2+c3_3*wt_3+c3_4*wt_4;
c4=c4_1*wt_1+c4_2*wt_2+c4_3*wt_3+c4_4*wt_4;
c5=c5_1*wt_1+c5_2*wt_2+c5_3*wt_3+c5_4*wt_4;

proc means;



