*table2 follows ssp4_54;

options ls=120 nocenter nofmterr;

libname ssp '/tmp/';

title1 '54 mo ssp data set  n=5617 (IC, no plus, re-aligned IA';

data one;
set ssp.wide54;

tr=1-control;
ssp_elig=(expt=2);

proc sort;
by tr;


proc means;
var control in18m in36mo  bc male age agelt25 kidslt6 kids615 imm asian
    momdad famwelf
    hsgrad exp div_sep nevermar premos lifer basework baselook
    likework ia1 ia6 ia12 ia18 ia24 ia32 ia40
    ia48 ia54 ia60 ia69 ssp_elig;

by tr;

proc sort;
by expt;
proc means;
var control in18m in36mo  bc male age agelt25 kidslt6 kids615 imm asian
    momdad famwelf
    hsgrad exp div_sep nevermar premos lifer basework baselook
    likework ia1 ia6 ia12 ia18 ia24 ia32 ia40
    ia48 ia54 ia60 ia69 ssp_elig;
by expt;


data one;
set ssp.wide54;
title1 'ssp long data set';

tr=(control=0);
id=_n_;

array ia (69) ia1-ia69;

do j=1 to 69;
 length onia onia1-onia3 3;
 length oniap1 oniap2 3;
 label onia='on ia this month'
       onia1='on ia last month'
       onia2='on ia 2 mos ago'
       onia3='on ia 3 mos ago'
       oniap1='on ia +1 mos'
       oniap2='on ia +2 mos' ;

 onia=ia(j);
 if j<=1 then onia1=1;
  else onia1=ia(j-1);
 if j<=2 then onia2=1;
  else onia2=ia(j-2);
 if j<=3 then onia3=1;
  else onia3=ia(j-3);
 if j<=68 then  oniap1=ia(j+1);
 if j<=67 then oniap2=ia(j+2);

month=j;


length welfare exit enter 3;
welfare=onia;
if onia1=1 then exit=1-onia; else exit=.;
if onia1=0 then enter=onia; else enter=.;

ssp_elig=(expt=2);


keep bc control expt in18m in36mo  basintdt
    kidslt6 anylt6 kids615 kidslt16 div_sep nevermar momdad imm
    asian native hsgrad higrad age baselook basework male premos
    likework emotprob physprob
    famwelf exp noexp agelt25 age2535 age35p lifer lowed
    tr welfare onia onia1-onia3 oniap1 oniap2 exit enter
    ten month ssp_elig in50mo;

output;
end;

proc means n mean stderr std min max;
where (tr=0 and month=1);
title2 'all controls';
var control in18m in36mo in50mo
    bc male age agelt25 kidslt6 kids615 imm asian
    momdad famwelf
    hsgrad exp div_sep nevermar premos lifer basework baselook
    likework ssp_elig ten;

proc means n mean stderr std min max;
where (tr=1 and month=1);
title2 'all programs';
var control in18m in36mo in50mo
    bc male age agelt25 kidslt6 kids615 imm asian
    momdad famwelf
    hsgrad exp div_sep nevermar premos lifer basework baselook
    likework ssp_elig ten;

proc means n mean stderr std min max;
where (month=1 and expt=1);
title2 'ineligible programs';
var control in18m in36mo in50mo
    bc male age agelt25 kidslt6 kids615 imm asian
    momdad famwelf
    hsgrad exp div_sep nevermar premos lifer basework baselook
    likework ssp_elig ten;

proc means n mean stderr std min max;
where (month=1 and expt=2);
title2 'eligible programs';
var control in18m in36mo in50mo
    bc male age agelt25 kidslt6 kids615 imm asian
    momdad famwelf
    hsgrad exp div_sep nevermar premos lifer basework baselook
    likework ssp_elig ten;



proc means n mean stderr std min max;
where (tr=0 and month<=16);
title2 'controls, months 1-16';
var control onia exit enter ;


proc means n mean stderr std min max;
where (tr=0 and 17<=month<=32);
title2 'controls, months 17-32';
var control onia exit enter ;

proc means n mean stderr std min max;
where (tr=0 and 33<=month<=48);
title2 'controls, months 33-48';
var control onia exit enter ;

proc means n mean stderr std min max;
where (tr=0 and 49<=month<=69);
title2 'controls, months 49-69';
var control onia exit enter ;



proc means n mean stderr std min max;
where (tr=1 and month<=16);
title2 'programs, months 1-16';
var control onia exit enter ;


proc means n mean stderr std min max;
where (tr=1 and 17<=month<=32);
title2 'programs, months 17-32';
var control onia exit enter ;

proc means n mean stderr std min max;
where (tr=1 and 33<=month<=48);
title2 'programs, months 33-48';
var control onia exit enter ;

proc means n mean stderr std min max;
where (tr=1 and 49<=month<=69);
title2 'programs, months 49-69';
var control onia exit enter ;



proc means n mean stderr std min max;
where (expt=1 and month<=16);
title2 'inelig programs, months 1-16';
var control onia exit enter ;


proc means n mean stderr std min max;
where (expt=1 and 17<=month<=32);
title2 'inelig programs, months 17-32';
var control onia exit enter ;

proc means n mean stderr std min max;
where (expt=1 and 33<=month<=48);
title2 'inelig programs, months 33-48';
var control onia exit enter ;

proc means n mean stderr std min max;
where (expt=1 and 49<=month<=69);
title2 'inelig programs, months 49-69';
var control onia exit enter ;



proc means n mean stderr std min max;
where (expt=2 and month<=16);
title2 'elig programs, months 1-16';
var control onia exit enter ;


proc means n mean stderr std min max;
where (expt=2 and 17<=month<=32);
title2 'elig programs, months 17-32';
var control onia exit enter ;

proc means n mean stderr std min max;
where (expt=2 and 33<=month<=48);
title2 'elig programs, months 33-48';
var control onia exit enter ;

proc means n mean stderr std min max;
where (expt=2 and 49<=month<=69);
title2 'elig programs, months 49-69';
var control onia exit enter ;

